000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. EVA01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  WORK.
000000     02 A100 PIC 9(3).
000000     02 A200 PIC 9(3).
000000     02 SYOKU   PIC X.   
000000     02 SEISEKI PIC X.
000000     02 KAZOKU PIC 9(2).
000000     02 NENREI  PIC 99.
000000     02 SALARY  PIC 9(7) VALUE 300000.
000000     02 AGE  PIC 9(3).  
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START EVA01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-EVA-RTN THRU 01-EVA-RTN-END. 
000000     PERFORM 02-EVA-RTN THRU 02-EVA-RTN-END. 
000000     PERFORM 03-EVA-RTN THRU 03-EVA-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END EVA01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-EVA-RTN 
000000******************************************************
000000 01-EVA-RTN.
000000     MOVE 2 TO A100.
000000     MOVE 77 TO A200. 
000000     EVALUATE A100 ALSO A200
000000         WHEN 1 ALSO 1 THRU 10
000000           DISPLAY "01-EVA-01[1] A100,A100 [" A100 "][" A200 "]" 
000000         WHEN 2 ALSO 11 THRU 99 
000000           DISPLAY "01-EVA-01[2] A100,A100 [" A100 "][" A200 "]" 
000000         WHEN OTHER 
000000           DISPLAY "01-EVA-01[3] A100,A100 [" A100 "][" A200 "]" 
000000     END-EVALUATE.
000000*    ***     
000000     EVALUATE A100 - 1 ALSO A200 - 70
000000         WHEN 1 ALSO 1 THRU 10
000000           DISPLAY "01-EVA-02(1) A100,A100 [" A100 "][" A200 "]" 
000000         WHEN 2 ALSO 11 THRU 99 
000000           DISPLAY "01-EVA-02(2) A100,A100 [" A100 "][" A200 "]" 
000000         WHEN OTHER 
000000           DISPLAY "01-EVA-02(3) A100,A100 [" A100 "][" A200 "]" 
000000     END-EVALUATE.
000000 01-EVA-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-EVA-RTN 
000000******************************************************
000000 02-EVA-RTN.
000000     MOVE "E" TO SYOKU.   
000000     MOVE "D" TO SEISEKI.
000000     MOVE 6 TO KAZOKU.
000000     MOVE 22 TO NENREI.
000000     MOVE 3 TO AGE.
000000     EVALUATE SYOKU ALSO SEISEKI ALSO TRUE ALSO NENREI  
000000         WHEN "E" ALSO "D" ALSO KAZOKU > 5 ALSO (25 - AGE) THRU 35
000000              COMPUTE SALARY = SALARY * 1.2
000000              DISPLAY "02-EVA-01(a) SALARY [" SALARY "]" 
000000         WHEN "K" ALSO "B" THRU "E" ALSO ANY ALSO ANY
000000              COMPUTE SALARY = SALARY * 1.3
000000              DISPLAY "02-EVA-01(b) SALARY [" SALARY "]" 
000000         WHEN "P" ALSO ANY ALSO ANY ALSO ANY 
000000              COMPUTE SALARY = SALARY * 1.5
000000              DISPLAY "02-EVA-01(c) SALARY [" SALARY "]" 
000000         WHEN OTHER  
000000              CONTINUE 
000000     END-EVALUATE. 
000000*    ***
000000     MOVE "K" TO SYOKU.   
000000     MOVE "C" TO SEISEKI.
000000     EVALUATE SYOKU ALSO SEISEKI ALSO TRUE ALSO NENREI  
000000         WHEN "E" ALSO "D" ALSO KAZOKU > 5 ALSO (25 - AGE) THRU 35
000000              COMPUTE SALARY = SALARY * 1.2
000000              DISPLAY "02-EVA-02(A) SALARY [" SALARY "]" 
000000         WHEN "K" ALSO "B" THRU "E" ALSO ANY ALSO ANY
000000              COMPUTE SALARY = SALARY * 1.3
000000              DISPLAY "02-EVA-02(B) SALARY [" SALARY "]" 
000000         WHEN "P" ALSO ANY ALSO ANY ALSO ANY 
000000              COMPUTE SALARY = SALARY * 1.5
000000              DISPLAY "02-EVA-02(C) SALARY [" SALARY "]" 
000000         WHEN OTHER  
000000              CONTINUE 
000000     END-EVALUATE. 
000000 02-EVA-RTN-END.
000000     EXIT.
000000******************************************************
000000*    03-EVA-RTN 
000000******************************************************
000000 03-EVA-RTN.
000000 03-EVA-RTN-END.
000000     EXIT.
