000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. INDEX05.
000000* << Ăяo >>
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000*...t@C
000000       SELECT  IND-FILE ASSIGN "index.dat"
000000         ORGANIZATION INDEXED
000000           ACCESS DYNAMIC
000000*           ACCESS SEQUENTIAL
000000*           ACCESS RANDOM
000000             RECORD KEY JUCD
000000               ALTERNATE RECORD KEY KOUZA
000000                 WITH DUPLICATES
000000               ALTERNATE RECORD KEY NENDO
000000                 WITH DUPLICATES
000000               ALTERNATE RECORD KEY GENGO
000000                 WITH DUPLICATES
000000               FILE   STATUS  IND-FST.   
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 FD  IND-FILE                                                             
000000     LABEL RECORD STANDARD.                         
000000 01  IND-REC.                  
000000     02 JUCD PIC 9(5).
000000     02 SIMEI PIC X(10).
000000     02 KOUZA PIC 9(5).
000000     02 NENDO PIC 9(4).  
000000     02 SU PIC S9(3)V99.
000000     02 GENGO PIC X(6). 
000000 WORKING-STORAGE SECTION.
000000 01  STATUS-AREA.                                        
000000     02 IND-FST  PIC  X(2).                  
000000     02 IND2-FST PIC  X(2).                  
000000     02 OUT-STS  PIC  X(4) VALUE ALL "X".                  
000000     02 OUT-STS2  PIC  X(4) VALUE HIGH-VALUES.                  
000000     02 OUT-STS3  PIC  X(4) VALUE LOW-VALUES.                  
000000     02 077OUT-NO PIC 9(4).                             
000000     02 WGENGO PIC X(6).
000000     02 WHIKAKU PIC 9(01).
000000     02 WSU    PIC S9(3)V99.
000000     02 WSU2    PIC X(7).
000000     02 WNENDO PIC X(4).
000000     02 WNENDO2 REDEFINES WNENDO PIC 9(4).  
000000     02 WKOUZA PIC X(5).
000000     02 WKOUZA2 REDEFINES WKOUZA PIC 9(5).
000000 01  WORK.
000000     02 INP-CNT PIC 9(6) VALUE ZERO.
000000     02 OUT-CNT PIC 9(6) VALUE 0.
000000     02 UPD-CNT PIC 9(6) VALUE 0.
000000     02 END-SW  PIC 9(1) VALUE ZERO. 
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START INDEX05" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-INDEX-RTN THRU 01-INDEX-RTN-END. 
000000     PERFORM 02-INDEX-RTN THRU 02-INDEX-RTN-END. 
000000     PERFORM 022-INDEX-RTN THRU 022-INDEX-RTN-END. 
000000     PERFORM 03-INDEX-RTN THRU 03-INDEX-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END INDEX05" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-INDEX-RTN Ăяo INPUT
000000******************************************************
000000 01-INDEX-RTN.
000000     DISPLAY "***** 01-INDEX-RTN Ăяo INPUT *****".
000000     PERFORM DISP-RTN THRU DISP-RTN-END. 
000000*... t@CI[v
000000     OPEN INPUT IND-FILE.    
000000     MOVE 3 TO JUCD. 
000000     READ IND-FILE
000000      INVALID            
000000        DISPLAY "READ INVALID JUCD=" JUCD " R[hȂI"
000000      NOT INVALID            
000000        DISPLAY "--- read jucd=(3) ------------"
000000        DISPLAY "jucd=" JUCD
000000        DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000     MOVE 33 TO JUCD. 
000000     READ IND-FILE
000000      INVALID            
000000        DISPLAY "READ INVALID JUCD=" JUCD " R[hȂI"
000000      NOT INVALID            
000000        DISPLAY "--- read jucd=(33) ------------"
000000        DISPLAY "jucd=" JUCD
000000        DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000     MOVE "php" TO GENGO. 
000000     READ IND-FILE KEY IS GENGO
000000       INVALID            
000000         DISPLAY "READ INVALID GENGO=" GENGO
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- read key=gengo=(php) ---------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "gengo=" GENGO
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000     MOVE "Ruby" TO GENGO. 
000000     READ IND-FILE KEY IS GENGO
000000       INVALID            
000000         DISPLAY "READ INVALID GENGO=" GENGO
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- read key=gengo=(php) ---------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "gengo=" GENGO
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000     CLOSE IND-FILE.  
000000 01-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-INDEX-RTN Ăяo OUTPUT Q
000000******************************************************
000000 02-INDEX-RTN.
000000     DISPLAY "***** 02-INDEX-RTN Ăяo OUTPUT Q *****".
000000     OPEN OUTPUT IND-FILE. 
000000*    ***       
000000     MOVE 77 TO JUCD. 
000000     MOVE "RANDOM77" TO SIMEI. 
000000     MOVE 77000 TO KOUZA. 
000000     MOVE 2015 TO NENDO. 
000000     MOVE -776.54 TO SU. 
000000     MOVE "vb.NET" TO GENGO. 
000000     WRITE IND-REC INVALID   
000000           DISPLAY "w INVALID" 
000000           STOP RUN. 
000000*    ***       
000000     MOVE 55 TO JUCD. 
000000     MOVE "RANDOM55" TO SIMEI. 
000000     MOVE 55000 TO KOUZA. 
000000     MOVE 2055 TO NENDO. 
000000     MOVE -554.32 TO SU. 
000000     MOVE "php5" TO GENGO. 
000000     WRITE IND-REC INVALID   
000000           DISPLAY "w INVALID" 
000000           STOP RUN. 
000000*    ***                               
000000     CLOSE IND-FILE. 
000000*    ***   
000000     PERFORM DISP-RTN THRU DISP-RTN-END. 
000000 02-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    022-INDEX-RTN Ăяo I-O Qǉ
000000******************************************************
000000 022-INDEX-RTN.
000000     DISPLAY "***** 022-INDEX-RTN Ăяo I-O add 2 *****".
000000     OPEN I-O IND-FILE. 
000000     DISPLAY "I-O <Add 2> jucd=(77,66)".
000000*    ***       
000000     MOVE 77 TO JUCD. 
000000     MOVE "RANDOM77" TO SIMEI. 
000000     MOVE 77000 TO KOUZA. 
000000     MOVE 2015 TO NENDO. 
000000     MOVE -776.54 TO SU. 
000000     MOVE "vb.NET" TO GENGO. 
000000     WRITE IND-REC INVALID   
000000           DISPLAY "write INVALID dH(77)" 
000000     END-WRITE. 
000000*    ***       
000000     MOVE 66 TO JUCD. 
000000     MOVE "RANDOM66" TO SIMEI. 
000000     MOVE 66000 TO KOUZA. 
000000     MOVE 2066 TO NENDO. 
000000     MOVE -664.32 TO SU. 
000000     MOVE "php66" TO GENGO. 
000000     WRITE IND-REC INVALID   
000000           DISPLAY "write INVALID dH(66)" 
000000     END-WRITE. 
000000*    ***                               
000000     CLOSE IND-FILE. 
000000*    ***                               
000000     PERFORM DISP-RTN THRU DISP-RTN-END. 
000000 022-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    03-INDEX-RTN Ăяo I-O
000000******************************************************
000000 03-INDEX-RTN.
000000     DISPLAY "***** 03-INDEX-RTN Ăяo I-O *****".
000000     OPEN I-O IND-FILE. 
000000*    ***       
000000     MOVE 55 TO JUCD. 
000000     READ IND-FILE
000000       INVALID            
000000         DISPLAY "READ INVALID JUCD=" JUCD 
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- read jucd=(55) ------------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000     MOVE "vb.NET" TO GENGO. 
000000     READ IND-FILE KEY IS GENGO
000000       INVALID            
000000         DISPLAY "READ INVALID JUCD=" JUCD 
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- read key=gengo=(vb.NET) ---------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "gengo=" GENGO
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000*    ***       
000000     MOVE 88 TO JUCD. 
000000     MOVE "Random88" TO SIMEI. 
000000     MOVE 88000 TO KOUZA. 
000000     MOVE 2088 TO NENDO. 
000000     MOVE -887.64 TO SU. 
000000     MOVE "PHP4" TO GENGO. 
000000     WRITE IND-REC INVALID   
000000           DISPLAY "WRITE INVALID JUCD=" JUCD
000000           " R[hI"
000000       NOT INVALID            
000000           DISPLAY "--- write(o) jucd=(88) ------------"
000000           DISPLAY "IND-REC=" IND-REC
000000     END-WRITE.                                                            
000000     MOVE 88 TO JUCD. 
000000     READ IND-FILE
000000       INVALID            
000000         DISPLAY "READ INVALID JUCD=" JUCD 
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- read jucd=(88) ------------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "kouza=" KOUZA
000000           DISPLAY "simei=" SIMEI
000000           DISPLAY "nendo=" NENDO
000000           DISPLAY "su=" SU
000000           DISPLAY "gengo=" GENGO
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000*    *** 
000000     MOVE "89Random" TO SIMEI. 
000000     MOVE 89089 TO KOUZA. 
000000     MOVE 8920 TO NENDO. 
000000     MOVE "PHP89" TO GENGO. 
000000     MOVE -898.98 TO SU. 
000000     REWRITE IND-REC
000000       INVALID 
000000         DISPLAY "REWRITE INVALID JUCD=" JUCD
000000                 " R[hȂI"
000000       NOT INVALID            
000000           DISPLAY "--- rewrite(XV) OK jucd=(88) --------"
000000     END-REWRITE.
000000*    *** 
000000     MOVE 88 TO JUCD.
000000     READ IND-FILE
000000       INVALID            
000000         DISPLAY "READ INVALID JUCD=" JUCD 
000000                 " R[hȂ???"
000000       NOT INVALID            
000000           DISPLAY "--- XV̓e --------"
000000           DISPLAY "jucd=" JUCD
000000           DISPLAY "*kouza=" KOUZA
000000           DISPLAY "*simei=" SIMEI
000000           DISPLAY "*nendo=" NENDO
000000           DISPLAY "*su=" SU
000000           DISPLAY "*gengo=" GENGO
000000           DISPLAY "IND-REC=" IND-REC
000000     END-READ.                                                            
000000*    ***                               
000000     DISPLAY "폜 DELETE JUCD=(55)".
000000     MOVE 55 TO JUCD. 
000000     DELETE IND-FILE
000000       INVALID            
000000         DISPLAY "DELETE INVALID JUCD=" JUCD 
000000                 " R[hȂ???"
000000       NOT INVALID            
000000           DISPLAY "--- delete(폜) OK jucd=(55) --------"
000000     END-DELETE.
000000*    ***                               
000000     DISPLAY "x폜 DELETE JUCD=(55)".
000000     MOVE 55 TO JUCD. 
000000     DELETE IND-FILE
000000       INVALID            
000000         DISPLAY "DELETE INVALID JUCD=" JUCD 
000000                 " R[hȂ???"
000000       NOT INVALID            
000000           DISPLAY "--- delete(폜) OK jucd=(55) --------"
000000     END-DELETE.
000000*    ***                               
000000 03-INDEX-RTN-CL.
000000     CLOSE IND-FILE. 
000000*    ***                               
000000     PERFORM DISP-RTN THRU DISP-RTN-END. 
000000 03-INDEX-RTN-END.
000000     EXIT.
000000******************************************************
000000*    DISP-RTN ׂĕ\
000000******************************************************
000000 DISP-RTN.
000000     DISPLAY "<-------ALL DISPLAY---------------------->s".
000000     OPEN INPUT IND-FILE.
000000     MOVE ZERO TO INP-CNT END-SW.  
000000*    ***                              
000000     PERFORM UNTIL END-SW = 1
000000       READ IND-FILE NEXT            
000000         AT END 
000000           MOVE 1 TO END-SW    
000000         NOT AT END
000000           ADD 1 TO INP-CNT
000000*****      DISPLAY "<-------ALL DISPLAY---------------------->"
000000           DISPLAY "IND-REC=" IND-REC
000000       END-READ                                                            
000000     END-PERFORM.
000000*    ***                               
000000     CLOSE IND-FILE. 
000000*    ***                               
000000     DISPLAY " INPUT=" INP-CNT.
000000     DISPLAY "<-------ALL DISPLAY---------------------->e".
000000 DISP-RTN-END.
000000     EXIT.
