000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. PERF02.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  WORK.
000000     02 CNT01 PIC 9(5).
000000     02 CNT02 PIC 9(5).
000000     02 CNT   PIC 9(5) VALUE ZERO.
000000 01  WORK-SUM.
000000     02 SUM01 PIC 9(4). 
000000     02 SUM02 PIC 9(4). 
000000     02 SUM03 PIC 9(4). 
000000     02 SUM04 PIC 9(4). 
000000     02 SUM05 PIC 9(4). 
000000 01  WORK2.
000000*     02 AI PIC 9(3).
000000*     02 BI PIC 9(3).
000000*     02 CI PIC 9(3).
000000*     02 ARY-AA OCCURS 3 . 
000000*      03 ARY-BB OCCURS 2 . 
000000*       04 ARY-CC OCCURS 4 PIC 9(04) . 
000000     02 ARY-AA OCCURS 3 INDEXED BY AI. 
000000      03 ARY-BB OCCURS 2 INDEXED BY BI. 
000000       04 ARY-CC OCCURS 4 INDEXED BY CI PIC 9(04) . 
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START PERF02" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 11-PERF-RTN THRU 11-PERF-RTN-END. 
000000     PERFORM 12-PERF-RTN THRU 12-PERF-RTN-END. 
000000     PERFORM 13-PERF-RTN THRU 13-PERF-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END PERF02" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    11-PERF-RTN S AFTER w(PERFORM)
000000******************************************************
000000 11-PERF-RTN.
000000*    ***(1) PERFORM,02-SUMRY-RTN߂s
000000     MOVE ZERO TO SUM01.
000000     PERFORM 02-SUMRY-RTN
000000         VARYING CNT01 FROM 1 BY 1 UNTIL CNT01 > 6
000000       AFTER CNT02 FROM 1 BY 1 UNTIL CNT02 > 6.
000000     DISPLAY "11-PERF(1) SUM01=" SUM01 " CNT01=" CNT01
000000             " CNT02=" CNT02.
000000*    ***(2)  (1) + TEST AFTER
000000     MOVE ZERO TO SUM01.
000000     PERFORM 02-SUMRY-RTN WITH TEST AFTER
000000         VARYING CNT01 FROM 1 BY 1 UNTIL CNT01 > 6
000000       AFTER CNT02 FROM 1 BY 1 UNTIL CNT02 > 6.
000000     DISPLAY "11-PERF(2) SUM01=" SUM01 " CNT01=" CNT01
000000             " CNT02=" CNT02.
000000*    ***(3) PERFORM,SET-01-RTN ` -ENDs,AFTER w x 2
000000     INITIALIZE WORK2.
000000     MOVE ZERO TO CNT01.
000000     PERFORM SET-01-RTN THRU SET-01-RTN-END
000000         VARYING AI FROM 1 BY 1 UNTIL AI > 3
000000         AFTER BI FROM 1 BY 1 UNTIL BI > 2
000000         AFTER CI FROM 1 BY 1 UNTIL CI > 4.
000000     DISPLAY "11-PERF(3a) ARY-AA=" ARY-AA(1) " " ARY-AA(3) " ".
000000     DISPLAY "11-PERF(3b) ARY-BB=" ARY-BB(1,1) " "
000000                                   ARY-BB(3,2) " ".
000000     DISPLAY "11-PERF(3c) ARY-CC=" ARY-CC(1,1,1) " "
000000                                   ARY-CC(3,2,4) " ".
000000*    ***(4) (3) + TEST AFTER
000000*    INITIALIZE WORK2.
000000*    MOVE ZERO TO CNT01.
000000*    PERFORM SET-01-RTN THRU SET-01-RTN-END TEST AFTER
000000*        VARYING AI FROM 1 BY 1 UNTIL AI > 3
000000*        AFTER BI FROM 1 BY 1 UNTIL BI > 2
000000*        AFTER CI FROM 1 BY 1 UNTIL CI > 4.
000000*    DISPLAY "11-PERF(4a) ARY-AA=" ARY-AA(1) " " ARY-AA(3) " ".
000000*    DISPLAY "11-PERF(4b) ARY-BB=" ARY-BB(1,1) " "
000000*                                  ARY-BB(3,2) " ".
000000*    DISPLAY "11-PERF(4c) ARY-CC=" ARY-CC(1,1,1) " "
000000*                                  ARY-CC(3,2,4) " ".
000000 11-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    12-PERF-RTN PERFORM ̎s͈͂Ɗ֐(C#ϊ)@
000000******************************************************
000000 12-PERF-RTN.
000000*    ***(1)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-01.
000000     DISPLAY "12-PERF(1a) " WORK-SUM. 
000000     DISPLAY "12-PERF(1b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(2)
000000     INITIALIZE WORK-SUM.
000000*****PERFORM KEISAN-01 THRU KEISAN-02.
000000     PERFORM KEISAN-02.
000000     DISPLAY "12-PERF(2a) " WORK-SUM. 
000000     DISPLAY "12-PERF(2b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(3)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-01-RTN01 THRU KEISAN-01-RTN-END.
000000     DISPLAY "12-PERF(3a) " WORK-SUM. 
000000     DISPLAY "12-PERF(3b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(4)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-01-RTN02 THRU KEISAN-01-RTN05.
000000     DISPLAY "12-PERF(4a) " WORK-SUM. 
000000     DISPLAY "12-PERF(4b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(5)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-02-RTN01 THRU KEISAN-02-RTN-END.
000000     DISPLAY "12-PERF(5a) " WORK-SUM. 
000000     DISPLAY "12-PERF(5b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(6)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-02-RTN02 THRU KEISAN-02-RTN03.
000000     DISPLAY "12-PERF(6a) " WORK-SUM. 
000000     DISPLAY "12-PERF(6b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000*    ***(7)
000000     INITIALIZE WORK-SUM.
000000     PERFORM KEISAN-01-RTN03 THRU KEISAN-01-RTN05.
000000     DISPLAY "12-PERF(7a) " WORK-SUM. 
000000     DISPLAY "12-PERF(7b) " SUM01 " " SUM02 " " SUM03 
000000                        " " SUM04 " " SUM05.
000000 12-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    13-PERF-RTN 
000000******************************************************
000000 13-PERF-RTN.
000000 13-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    SET-01-RTN
000000******************************************************
000000 SET-01-RTN.
000000     ADD 1 TO CNT01.
000000     MOVE CNT01 TO ARY-CC ( AI BI CI ) . 
000000 SET-01-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SUMRY-RTN section
000000******************************************************
000000* 01-SUMRY-RTN SECTION.
000000*     COMPUTE SUM01 = SUM01 + CNT. 
000000* 01-SUMRY-RTN-END.
000000*     EXIT.
000000******************************************************
000000*    02-SUMRY-RTN section
000000******************************************************
000000 02-SUMRY-RTN SECTION.
000000     COMPUTE SUM01 = SUM01 + CNT01 + CNT02. 
000000 02-SUMRY-RTN-END.
000000     EXIT.
000000******************************************************
000000*    KEISAN-01 
000000******************************************************
000000 KEISAN-01 SECTION.
000000 KEISAN-01-RTN01.
000000     ADD 1 TO SUM01. 
000000 KEISAN-01-RTN02.
000000     ADD 2 TO SUM02. 
000000 KEISAN-01-RTN03.
000000     ADD 3 TO SUM03. 
000000 KEISAN-01-RTN04.
000000     ADD 4 TO SUM04. 
000000 KEISAN-01-RTN05.
000000     ADD 5 TO SUM05. 
000000 KEISAN-01-RTN-END.
000000     EXIT.
000000******************************************************
000000*    KEISAN-02 
000000******************************************************
000000 KEISAN-02 SECTION.
000000 KEISAN-02-RTN01.
000000     ADD 11 TO SUM01. 
000000 KEISAN-02-RTN02.
000000     ADD 12 TO SUM02. 
000000 KEISAN-02-RTN03.
000000     ADD 13 TO SUM03. 
000000 KEISAN-02-RTN04.
000000     ADD 14 TO SUM04. 
000000 KEISAN-02-RTN05.
000000     ADD 15 TO SUM05. 
000000 KEISAN-02-RTN-END.
000000     EXIT.
