000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. SET01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000  01 WCNT.
000000     02 CNT PIC 9(5) OCCURS 5 
000000          INDEXED BY CI01 CI02 CI03 CI04 CI05.
000000 01  UIX USAGE INDEX. 
000000 77  YIX USAGE INDEX.
000000 01  WWW.
000000     02 ZIX  USAGE IS INDEX.
000000  01 GENGO-W.
000000     02 PIC X(10) VALUE "COBOL"  002 PIC 9(3)  VALUE 100.
000000     02 PIC X(10) VALUE "FORTRAN".
000000     02 PIC 9(3)  VALUE 120.
000000     02 PIC X(10) VALUE "C". 02 PIC 9(3)  VALUE 200.
000000     02 PIC X(10) VALUE "C++".
000000     02 PIC 9(3)  VALUE 210.
000000     02 PIC X(10) VALUE "BASIC".
000000     02 PIC 9(3)  VALUE 300.
000000     02 PIC X(10) VALUE "PERL".
000000     02 PIC 9(3)  VALUE 400.
000000     02 PIC X(10) VALUE "PHP".
000000     02 PIC 9(3)  VALUE 410.
000000     02 PIC X(10) VALUE "VB.NET".
000000     02 PIC 9(3)  VALUE 500.
000000     02 PIC X(10) VALUE "C#.NET".
000000     02 PIC 9(3)  VALUE 510.
000000  01 REDEFINES GENGO-W.
000000     02 GENGO OCCURS 9 TIMES 
000000          INDEXED BY IX01 IX02 IX03 IX04 IX05.
000000      03 G-NAME PIC X(10).
000000      03 G-NO   PIC 9(3).
000000  01  WORK.
000000      03 KUNI-JYOHO.                      
000000        05 FILLER PIC X(19) VALUE "001Canada   America". 
000000        05 FILLER PIC X(19) VALUE "001Hawaii   Oceania". 
000000        05 FILLER PIC X(19) VALUE "001USA      America". 
000000        05 FILLER PIC X(19) VALUE "007Russia   Europe ". 
000000        05 FILLER PIC X(19) VALUE "049Germany  Europe ". 
000000        05 FILLER PIC X(19) VALUE "081Japan    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "082Korea    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "084Viet Nam Asia   ". 
000000        05 FILLER PIC X(19) VALUE "086China    Asia   ".
000000        05 FILLER PIC X(19) VALUE "090Turkey   Europe ".
000000        05 FILLER PIC X(19) VALUE "680Palau    Oceania". 
000000        05 FILLER PIC X(19) VALUE "852Hong KongAsia   ".
000000        05 FILLER PIC X(19) VALUE "886Taiwan   Asia   ".
000000      03 KUNI-JYOHO-R REDEFINES KUNI-JYOHO.          
000000        05 KUNI-TBL OCCURS 13 ASCENDING KEY KUNI 
000000                      INDEXED BY KI01 KI02 KI03 KI04 KI05.   
000000          07 KUNI .         
000000            09 KUNI-NO   PIC 9(03).
000000            09 KUNI-NAME PIC X(09).         
000000          07 KUNI-CHIIKI PIC X(7).               
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START SET01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-SET-RTN THRU 01-SET-RTN-END. 
000000     PERFORM 01-GO-RTN THRU 01-GO-RTN-END. 
000000     PERFORM 02-GO-RTN THRU 02-GO-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END SET01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SET-RTN rds, USAGE INDEX 
000000******************************************************
000000 01-SET-RTN.
000000     SET CI05 TO 1.
000000     SET UIX YIX ZIX TO CI05.
000000     MOVE 3 TO CNT (CI05). 
000000     SET CI01 CI02 CI03 CI04 CI05 TO CNT ( CI05 ).
000000     DISPLAY "SET(1) ci01=" CI01 " ci05=" CI05 
000000       " UIX=" UIX " YIX=" YIX " ZIX=" ZIX.  
000000     SET IX01 IX02 IX03 IX04 IX05 TO 5.
000000     DISPLAY "SET(2) IX01=" IX01 " g-name=" G-NAME (IX01).
000000     SET  KI01 KI02 KI03 KI04 KI05 TO 13.
000000     DISPLAY "SET(3) KI05=" KI05 " kuni-name=" KUNI-NAME (KI05).
000000 01-SET-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-GO-RTN GO DEPENDING
000000******************************************************
000000 01-GO-RTN.
000000     SET CI05 TO 3.
000000     SET CNT (CI05) TO CI05.  
000000     DISPLAY CI05 " cnt=" CNT (CI05) . 
000000     GO TO 01-GO-RTN01 01-GO-RTN02 01-GO-RTN03 01-GO-RTN04 
000000         DEPENDING ON CNT (CI05).
000000 01-GO-RTN01.
000000     DISPLAY "GO(1) " CI05.
000000 01-GO-RTN02.
000000     DISPLAY "GO(2) " CI05.
000000 01-GO-RTN03.
000000     DISPLAY "GO(3) " CI05.
000000 01-GO-RTN04.
000000     DISPLAY "GO(4) " CI05.
000000 01-GO-RTN05.
000000     DISPLAY "GO(?) " CI05.
000000 01-GO-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-GO-RTN GO DEPENDING
000000******************************************************
000000 02-GO-RTN.
000000     SET CI05 TO 5.
000000     SET CNT (CI05) TO CI05.  
000000     DISPLAY CI05 " cnt=" CNT (CI05) . 
000000     GO TO 02-GO-RTN01 02-GO-RTN02 02-GO-RTN03 02-GO-RTN04 
000000         DEPENDING ON CNT (CI05).
000000 02-GO-RTN01.
000000     DISPLAY "GO(1) " CI05.
000000 02-GO-RTN02.
000000     DISPLAY "GO(2) " CI05.
000000 02-GO-RTN03.
000000     DISPLAY "GO(3) " CI05.
000000 02-GO-RTN04.
000000     DISPLAY "GO(4) " CI05.
000000 02-GO-RTN05.
000000     DISPLAY "GO(?) " CI05.
000000 02-GO-RTN-END.
000000     EXIT.
